import unittest
from abc import ABC, abstractmethod

#Interface für Counter
class ICounter(ABC):
    @abstractmethod
    def count_ED(self, s):
        pass

# Implementierung Counter Klasse
class Counter(ICounter):
       def count_ED(self, s):
           s = s.upper()
           return s.count("D") + s.count("E")

class TextCounter (unittest.TestCase):
    def setUp(self):
        self.c = Counter()

    def test_count_ED_regular(self):
        ergebnis = self.c.count_ED("Decker")
        self.assertEqual(ergebnis, 3)

    def test_count_ED_empty(self):
        ergebnis = self.c.count_ED("")
        self.assertEqual(ergebnis, 0)

    def test_count_ED_wo(self):
        '''Testet einen String ohne E und D'''
        ergebnis = self.c.count_ED("HAllo")
        self.assertEqual(ergebnis, 0)

    def test_count_ED_insensitive(self):
        '''Testet verschiedene Groß- und Kleinschreibung '''
        ergebnis = self.c.count_ED("Der Esel")
        self.assertEqual(ergebnis, 4)
   
    def test_count_ED_single_letter(self):
        '''Testet Eingaben mit nur einem Buchstaben'''
        ergebnis = self.c.count_ED("D")
        self.assertEqual(ergebnis, 1)
        ergebnis = self.c.count_ED("E")
        self.assertEqual(ergebnis, 1)
        ergebnis = self.c.count_ED("d")
        self.assertEqual(ergebnis, 1)
        ergebnis = self.c.count_ED("e")
        self.assertEqual(ergebnis, 1)

if __name__ == "__main__":
    unittest.main()